unit MuCpMth;

interface

uses WinTypes, Classes, Forms, StdCtrls, Dialogs, SysUtils, Messages, FileCtrl;

type
    TCopyForm = class(TForm)
       procedure WMNCHitTest(var M: TWMNCHitTest); message WM_NCHitTest;
       end;

    TCopy=class(TThread)
       private
          procedure Execute; override;
          procedure KillThread(Sender: TObject; var CanClose: Boolean);
          procedure CancelClick(Sender: TObject);
       protected
          CopySource : string;
          CopyTarget : string;
          CopyForm : TCopyForm;
          CopyFrom : TLabel;
          CopyTo : TLabel;
          CancelButton : TButton;
          Killed:boolean;
          CopyFinished : boolean;
          SObj,TObj: TDirectoryListBox;
       public
          constructor Create(Source, Target : string;         {source and target}
                             S,T: TDirectoryListBox);         {directories to update}
          end;

       MCopy=class(TThread)
          private
             CopyParent : TCopy;
             procedure Execute; override;
          public
             constructor Create(TCopyParent : TCopy);
          protected
          end;

implementation

constructor TCopy.Create(Source, Target : string;S,T:TDirectoryListBox);
begin
   SObj:=S;
   TObj:=T;
   CopySource := ExpandFileName(Source);
   CopyTarget := ExpandFileName(Target);
   if CopySource=CopyTarget then begin
      MessageDlg('The copy operation cannot be performed.'+Chr(10)+Chr(13)+'Source and destination folders cannot be the same!',mtError,[mbOk],0);
      exit;
      end;
   if Pos(CopySource,CopyTarget)=1 then begin
      MessageDlg('The copy operation cannot be performed.'+Chr(10)+Chr(13)+'The destination folder is a subfolder of the source folder!',mtError,[mbOk],0);
      exit;
      end;
   Killed:=False;
   CopyFinished:=False;
   inherited Create(False);
   end;

procedure TCopy.Execute;
begin
   {create and initialize the copy form}
   CopyForm := TCopyForm.CreateNew(Application);
   with CopyForm do begin
      BorderIcons:=[biSystemMenu];
      BorderStyle:=bsDialog;
      Caption:='MuCopy (c) Stolen Technologies Inc, handle: '+IntToStr(Handle);
      Position:=poDesigned;
      Width:=400;
      Height:=100;
      Left:=Random(Screen.Width);
      Top:=Random(Screen.Height);
      if Left>Screen.Width-Width then Left:=Screen.Width-Width;
      if Top>Screen.Height-Height then Top:=Screen.Height-Height;
      OnCloseQuery:=KillThread;
      end;
   {create and initialize the copy form status label}
   CopyFrom := TLabel.Create(CopyForm);
   with CopyFrom do begin
      Caption:='Copying ' + CopySource + ' to ' + CopyTarget;
      Top:=CopyForm.ClientHeight div 3 - CopyFrom.Height div 2;
      Left:=CopyForm.ClientWidth div 2 - CopyFrom.Width div 2;
      end;
   CopyForm.InsertControl(CopyFrom);
   CopyTo := TLabel.Create(CopyForm);
   with CopyTo do begin
      Caption:='';
      Top:=CopyFrom.Height+CopyFrom.Top;
      Left:=CopyForm.ClientWidth div 2 - CopyTo.Width div 2;
      end;
   CopyForm.InsertControl(CopyTo);
   {create and initialize the cancel button}
   CancelButton:=TButton.Create(CopyForm);
   with CancelButton do begin
      Name:='CancelButton';
      Caption:='Cancel';
      Top:=CopyForm.ClientHeight - CopyForm.ClientHeight div 3 - CancelButton.Height div 3;
      Left:=CopyForm.ClientWidth div 2 - CancelButton.Width div 2;
      OnClick:=CancelClick;
      end;
   CopyForm.InsertControl(CancelButton);


   CopyForm.Show;
   MCopy.Create(Self);
   while not(CopyFinished) do begin
      Application.ProcessMessages;
      Sleep(0);
      end;
   SObj.Update;
   TObj.Update;
   end;

constructor MCopy.Create(TCopyParent : TCopy);
begin
   CopyParent:=TCopyParent;
   inherited Create(False);
   end;

procedure MCopy.Execute;
var
   FilePath:string;
   FilePathLen: integer;
   TargetCopy : string;
   OverWrite : boolean;

 procedure DirectoryRecurse(Directory : string);
 var
    Result : integer;
    SearchRec: TSearchRec;
    DisplacePath : string;
    RealSource:string;
    RealTarget:string;
    StringSource, StringTarget:string;
    OW: word;
 begin
    DisplacePath:=Directory;
    Delete(DisplacePath,1,FilePathLen);
    ForceDirectories(ExpandFileName(TargetCopy+DisplacePath));
    if not(DirectoryExists(ExpandFileName(TargetCopy+DisplacePath))) then begin
       MessageDlg('The copy operation cannot be performed.'+Chr(10)+Chr(13)+'Unable to create the following directory:'+Chr(10)+Chr(13)+ExpandFileName(TargetCopy+DisplacePath),mtError,[mbOk],0);
       CopyParent.Killed:=True;
       exit;
       end;
    Result := FindFirst(Directory+'*.*', faAnyFile, SearchRec);
    while Result = 0 do begin
       if CopyParent.Killed then exit;
       Application.ProcessMessages;
       with SearchRec do begin
         if (Name<>'.') and (Name<>'..') then begin
            if ((faDirectory and Attr) > 0) then DirectoryRecurse(ExtractFilePath(Directory)+Name+'\') else begin
               if CopyParent.Killed then exit else begin
               {update status}
               RealSource:=ExpandFileName(Directory+SearchRec.Name);
               RealTarget:=ExpandFileName(TargetCopy+DisplacePath+SearchRec.Name);

               StringSource:=RealSource;
               if Length(Directory)>50 then begin
                  Delete(StringSource,4,Length(StringSource)-50);
                  Insert('...',StringSource,4);
                  end;

               StringTarget:=RealTarget;
               if Length(StringTarget)>50 then begin
                  Delete(StringTarget,4,Length(StringTarget)-50);
                  Insert('...',StringTarget,4);
                  end;

               with CopyParent.CopyFrom do begin
                  Caption:='Copying ' + StringSource;
                  Top:=CopyParent.CopyForm.ClientHeight div 5 - CopyParent.CopyFrom.Height div 2;
                  Left:=CopyParent.CopyForm.ClientWidth div 2 - CopyParent.CopyFrom.Width div 2;
                  Update;
                  end;
               with CopyParent.CopyTo do begin
                  Caption:='to '+StringTarget;
                  Top:=CopyParent.CopyFrom.Height+CopyParent.CopyFrom.Top;
                  Left:=CopyParent.CopyForm.ClientWidth div 2 - CopyParent.CopyTo.Width div 2;
                  end;
                  {copy the file}
                  ow:=mrYes;
                  if FileExists(RealTarget) then
                  if not(Overwrite) then Ow:=MessageDlg('Do you wish to overwrite '+Chr(10)+Chr(13)+RealTarget+' ?',mtConfirmation,[mbYes,mbNo,mbAll],0);
                  if Ow=mrAll then OverWrite:=True;
                  if (Ow=mrYes) or OverWrite then begin
                     if CopyFile(PChar(RealSource),PChar(RealTarget),False)=False then begin
                        MessageDlg('The copy operation cannot be performed.'+Chr(10)+Chr(13)+SysErrorMessage(GetLastError),mtError,[mbOk],0);
                        CopyParent.Killed:=True;
                        exit;
                        end;
                     end;
                    end;
                  end;
               end;
            end;
         Result := FindNext(SearchRec);
       end;
    FindClose(SearchRec);
    end;
var
   i : integer;
   TopPath: string;
begin
   OverWrite:=False;
   FilePath:=ExpandFileName(CopyParent.CopySource);
   for i:=Length(FilePath) downto 0 do begin
      if FilePath[i]='\' then break;
      end;
   TopPath:=Copy(FilePath,i+1,Length(FilePath));
   FilePathLen:=Length(FilePath);
   TargetCopy:=ExpandFileName(CopyParent.CopyTarget+'\'+TopPath);
   DirectoryRecurse(CopyParent.CopySource+'\');
   CopyParent.CopyFinished:=True;
   end;

procedure TCopy.KillThread(Sender: TObject; var CanClose: Boolean);
begin
     if MessageDlg('Do you wish to cancel the copy operation (handle: '+IntToStr(Handle)+') ?',mtConfirmation,[mbYes] + [mbNo],0)=mrYes then begin
        Killed:=True;
        end;
        CanClose:=False;
   end;

procedure TCopy.CancelClick(Sender: TObject);
begin
   CopyForm.Close;
   end;

Procedure TCopyForm.WMNCHitTest(var M: TWMNCHitTest);
begin
   inherited;
   if M.Result = htClient then
      M.Result := htCaption;
   end;

end.
